PRO cut,l,f,l0,l1,new_l,new_f,len

; version 3.0
; 19 Mar 02 - prevent crash when no overlap found
;  9 Aug 01 - to handle non-overlap between segment and l0-l1
; 20 Oct 97 - created
;
; cuts a spectrum to fit within given wavelength range
; input:
;	l = spectral wavelengths
;	f = spectral fluxes (must be same length as l)
;	l0 = starting wavelength
;	l1 = stopping wavelength
; output:
;       new_l = new wavelength 
;       new_f = new flux
;       len   = new length, =0 if cut range didn't overlap with data

; make sure wavelength range overlaps data 

error=0
if (min(l) gt l1 or max(l) lt l0) then error=1

jstop = max(size(l))-1 ; OK since l is 1-D

; if good, set stops and trim data
;  otherwise copy data into new arrays, but set len=0

if (error eq 0) then begin

  j = 0     & while (l(j) lt l0) do j=j+1 & j0 = j
  j = jstop & while (l(j) gt l1) do j=j-1 & j1 = j

  new_l = l(j0:j1)
  new_f = f(j0:j1)
  len   = j1-j0+1

endif else begin

  new_l = l
  new_f = f
  len   = 0
endelse

end
