PRO segmenterr,grid_n,grid_p,cnt_n,cnt_p,l_lo,l_hi,err_hi

; version 3.0
; 27 Feb 02  to regrid error array internally
;  3 Aug 01  to add count arrays and find uncertainty in mean
;  2 Aug 01  created
;
; generates an error vector from data from both up and down scans gridded
;   to a common wavelength grid

s=size(grid_n)
istop=s(2)
err_lo=fltarr(istop)
len_n=max(size(cnt_n))
len_p=max(size(cnt_p))
count=float(len_n+len_p)

for i=0,istop-1 do begin
  sum   = 0.0
  sumsq = 0.0
  for j=0,len_n-1 do begin
   sum = sum + grid_n(j,i)
   sumsq = sumsq + grid_n(j,i)*grid_n(j,i)
  endfor
  for j=0,len_p-1 do begin
   sum = sum + grid_p(j,i)
   sumsq = sumsq + grid_p(j,i)*grid_p(j,i)
  endfor
  err_lo(i) = sqrt((sumsq/(count-1)) - (sum*sum/(count*(count-1))))
endfor

; calculate uncertainty in mean from standard deviation

for i=0,istop-1 do err_lo(i) = err_lo(i) / sqrt(count)

; determine value needed for regridding sigma

avg_len =  (total(cnt_p) + total(cnt_n)) / count
l_del = (max(l_lo)-min(l_lo))/float(avg_len)
newsig = 5.0*l_del

; regrid error to hi-res wavelength grid

s=max(size(l_lo)) ; OK since l_lo is 1-D
sorterror=fltarr(2,s)
sorterror(0,*)=l_lo
sorterror(1,*)=err_lo
err_hi=gridlo(sorterror,l_hi,sigma=newsig)

end
