PRO swsmake1

; version 4.0
; 29 Mar 02  to drop printing of normalizations to data file header
; 27 Feb 02  to reformat output:  extra col for each entry in header lines
;            extra error column in output, reduce cols for flux and error
; 25 Jan 02  to change up/down weighting for Band 2 to 0.5/0.5
;  8 Aug 01  to improve format of header to all.pws file
;  7 Aug 01  to open file 'all.lg1' log file
;            so segment procedures can write to it
; 31 Jul 01  to pass segment no. and wt_n to segment
;            also add 3rd header line to output
; 20 Jul 01 by splitting swsmake.pro into 2
; created as testload.pro, renamed isoload.pro, then swsmake.pro
;
; this is the procedure to load and correct all 12 SWS spectral segments

; open output files

close,99
openw,99,'all.log'
close,9
openw,9,'all.pws'
printf,99,'Log information from swsmake1.pro'

; load each segment by calling segment.pro
; produces one regridded spectrum per segment
; prints it out in file all.pws - preliminary sws file

segment,'f01ns.dat','f01ps.dat',l01,f01,e01,flag01,seg=1
segment,'f02ns.dat','f02ps.dat',l02,f02,e02,flag02,seg=2
segment,'f03ns.dat','f03ps.dat',l03,f03,e03,flag03,seg=3
segment,'f04ns.dat','f04ps.dat',l04,f04,e04,flag04,seg=4
segment,'f05ns.dat','f05ps.dat',l05,f05,e05,flag05,seg=5
segment,'f06ns.dat','f06ps.dat',l06,f06,e06,flag06,seg=6
segment,'f07ns.dat','f07ps.dat',l07,f07,e07,flag07,seg=7
segment,'f09ns.dat','f09ps.dat',l09,f09,e09,flag09,seg=9
segment,'f10ns.dat','f10ps.dat',l10,f10,e10,flag10,seg=10
segment,'f11ns.dat','f11ps.dat',l11,f11,e11,flag11,seg=11
segment,'f12ns.dat','f12ps.dat',l12,f12,e12,flag12,seg=12
segment,'f13ns.dat','f13ps.dat',l13,f13,e13,flag13,seg=13,wt_n=1.0

s=intarr(12)
s(0)=max(size(l01))  & s(1)=max(size(l02))  & s(2)=max(size(l03))
s(3)=max(size(l04))  & s(4)=max(size(l05))  & s(5)=max(size(l06))
s(6)=max(size(l07))  & s(7)=max(size(l09))  & s(8)=max(size(l10))
s(9)=max(size(l11))  & s(10)=max(size(l12)) & s(11)=max(size(l13))

flag=intarr(12)
flag(0)=flag01  & flag(1)=flag02  & flag(2)=flag03
flag(3)=flag04  & flag(4)=flag05  & flag(5)=flag06
flag(6)=flag07  & flag(7)=flag09  & flag(8)=flag10
flag(9)=flag11  & flag(10)=flag12 & flag(11)=flag13

nfact=fltarr(12)
for i=0,11 do if (flag(i) eq 0) then nfact(i)=1.0 else nfact(i)=0.0

printf,9,format='(12(i6))',s
printf,9,format='(12(i6))',flag
printf,99,''
printf,99,format='("Seg.:",12(i6))',[1,2,3,4,5,6,7,9,10,11,12,13]
printf,99,format='("Len.:",12(i6))',s
printf,99,format='("Flag:",12(i6))',flag

for i=0,s(0)-1 do printf,9,format='(f8.5,3(f9.2))',l01(i),f01(i),e01(i),e01(i)
for i=0,s(1)-1 do printf,9,format='(f8.5,3(f9.2))',l02(i),f02(i),e02(i),e02(i)
for i=0,s(2)-1 do printf,9,format='(f8.5,3(f9.2))',l03(i),f03(i),e03(i),e03(i)
for i=0,s(3)-1 do printf,9,format='(f8.5,3(f9.2))',l04(i),f04(i),e04(i),e04(i)
for i=0,s(4)-1 do printf,9,format='(f8.5,3(f9.2))',l05(i),f05(i),e05(i),e05(i)
for i=0,s(5)-1 do printf,9,format='(f8.5,3(f9.2))',l06(i),f06(i),e06(i),e06(i)
for i=0,s(6)-1 do printf,9,format='(f8.5,3(f9.2))',l07(i),f07(i),e07(i),e07(i)
for i=0,s(7)-1 do printf,9,format='(f8.5,3(f9.2))',l09(i),f09(i),e09(i),e09(i)
for i=0,s(8)-1 do printf,9,format='(f8.5,3(f9.2))',l10(i),f10(i),e10(i),e10(i)
for i=0,s(9)-1 do printf,9,format='(f8.5,3(f9.2))',l11(i),f11(i),e11(i),e11(i)
for i=0,s(10)-1 do printf,9,format='(f8.5,3(f9.2))',l12(i),f12(i),e12(i),e12(i)
for i=0,s(11)-1 do printf,9,format='(f8.5,3(f9.2))',l13(i),f13(i),e13(i),e13(i)

close,9
close,99

return
end
